d("customPDPView",['ccrz', 'util'], function(CCRZ, UTIL) {

    var runDefaultJsFunctions = function(){
        initTooltip();
        initCustomForms();
        businessLayout();
        initCustomLabel();
        initRetinaCover();
        initCustomHover();
        runHandleBarJsHelpers();
    }

    return {
        staticResourceUrls: {
            egressTheme: ''
        },
        runDefaultJs: function(){
            setTimeout(() => {
                runDefaultJsFunctions();
            }, 500);
        },
        extendCustomPDPView: function() {
            CCRZ.custom = _.extend(CCRZ.custom||{}); 
            CCRZ.custom.views = _.extend(CCRZ.custom.views||{}); 
            CCRZ.custom.models = _.extend(CCRZ.custom.models||{}); 
            CCRZ.remoteActions = _.extend(CCRZ.remoteActions||{}); 
            setTimeout(() => {
                runDefaultJsFunctions();
            }, 500);
            let isRefreshed = false, isBackward = false;
            CCRZ.pubSub.on('view:cartView:refresh', function(cartView){
                cartView.renderDesktop = function(){
                    let view = this;
                    view.setElement($(CCRZ.uiProperties.miniCartView.desktop.selector));
                    view.$el.html(view.templateDesktop(view.cartmodel.toJSON()));
                    CCRZ.prodDetailView.model.set('cartItems', CCRZ.cartView.cartmodel);
                    //UTIL.calculateSubscriptionPrices(view.cartmodel.get('cartItems'), CCRZ.prodDetailView, 'review');
                    CCRZ.prodDetailView.render();
                    setTimeout(() => {
                        runDefaultJsFunctions();
                    }, 500);
                }
                cartView.delegateEvents();
            });
            CCRZ.pubSub.once('view:productDetailView:refresh', function(detailView){
                    CCRZ.remoteActions.pdpRemoting =  _.extend(CCRZ.RemoteInvocation,{ 
                        className : 'CHVACB2B_pdp_Controller', 
                        addToCart : function( reqData,callback){ 
                            this.invokeCtx('addToCart', 
                                reqData,  
                                function(resp, evt){ 
                                    if(callback){
                                        callback(resp,evt);
                                    }            
                                }, 
                                { 
                                    buffer:false, 
                                    nmsp : false 
                                } 
                            );
                        },
                        getCartDataBySku: function( reqData,callback){ 
                            this.invokeCtx('getCartDataBySku', 
                                reqData,  
                                function(resp, evt){ 
                                    if(callback){
                                        callback(resp,evt);
                                    }            
                                }, 
                                { 
                                    buffer:false, 
                                    nmsp : false 
                                } 
                            );
                        }
                    });
                    var historyTraversal = ( typeof window.performance != "undefined" && 
                                        window.performance.navigation.type === 2 );
                    if ( historyTraversal && !isBackward) {
                        // Handle page restore.
                        CCRZ.remoteActions.pdpRemoting.className = 'CHVACB2B_pdp_Controller';
                        CCRZ.remoteActions.pdpRemoting.getCartDataBySku(JSON.stringify({'sku': CCRZ.pagevars.queryParams.sku}),function(res,event){
                            if(res && res.data && res.data.cartData && !isBackward){
                                CCRZ.productDetailModel.attributes.product.prodBean.cartData = res.data.cartData;
                                if(res.data.cartData.cartEncId){
                                    CCRZ.pagevars.currentCartID = res.data.cartData.cartEncId;
                                    CCRZ.pagevars.queryParams['cartId'] = res.data.cartData.cartEncId;
                                }
                                if(res.data.cartInfo){
                                    CCRZ.headerView.updateCart(res.data.cartInfo);
                                }
                                isBackward = true;
                                detailView.render();
                                setTimeout(() => {
                                    runDefaultJsFunctions();
                                }, 500);
                            }
                        }); 
                    }
                    detailView.setDynamicKitData = function(){
                        setDynamicKitDataToGuide(detailView);
                    };
                    setTimeout(function(){
                        CCRZ.prodDetailView.model.set('cartItems', CCRZ.cartView.cartmodel);
                        //UTIL.calculateSubscriptionPrices(CCRZ.cartView.cartmodel.get('cartItems'), CCRZ.prodDetailView, 'review');
                        detailView.render();
                        setTimeout(() => {
                            runDefaultJsFunctions();
                        }, 500);
                    }, 1500);
                    let ProductType = detailView.model.attributes.product.prodBean.ProductType;
                    let quantity = 1, frequencyTerm = (ProductType == 'Product'?'Monthly':'One-Time'), loaderTimeout = 500;
                    let frequencyTermId = (detailView.model.attributes.subProdTerms?detailView.model.attributes.subProdTerms[0].sfid:'');
                    detailView.model.set('frequencyTerm', frequencyTerm);
                    detailView.model.set('frequencyTermId', frequencyTermId);
                    if(detailView.model.attributes.subProdTerms ){
                        UTIL.validateDisplayName(detailView.model.attributes.subProdTerms[0], detailView);
                    }
                    detailView.model.set('quantity', quantity);
                    if(ProductType == "Aggregated"){
                        let compositeProds = detailView.model.attributes.product.prodBean.compositeProductsS;
                        if(compositeProds && compositeProds.length > 0){
                            compositeProds.forEach(function(prod, index){
                                prod['isChecked'] = (index == 0?true:false);
                            });
                        }
                    }
                    if(ProductType == 'Dynamic Kit' || ProductType == 'Kit'){
                        debugger;
                        setDynamicKitDataToGuide(detailView);
                        calculateBundlePrice(detailView, false);
                    } else {
                        calculateProductPrice(detailView, false);
                    }
                    detailView.events["click .add_to_cart_button"]  = "clickedOnAddToCart";
                    detailView.events["click .buy_now_button"]  = "clickedOnAddToCart";
                    detailView.events["click .add_bolt_on_button"] = "clickedOnAddBoltOn";
                    detailView.events["click .jcf-btn-inc"]  = "onProductQuantityChange";
                    detailView.events["click .jcf-btn-dec"]  = "onProductQuantityChange";
                    detailView.events["click .productName"]  = "gotoProductDetail";
                    detailView.events["click .quantityContainer .compositePlus"]  = "onHandleCompositeProducts";
                    detailView.events["change .quantityContainer .quantity"]  = "onHandleCompositeProducts";
                    detailView.events["click .quantityContainer .compositeMinus"]  = "onHandleCompositeProducts";
                    detailView.events["keypress #product_quantity"] = "validateCartQuantity";
                    detailView.events["change #product_quantity"]  = "onProductQuantityChange";
                    detailView.events["change .composite_product_select"]  = "onCompositeProductChange";
                    detailView.events["change .spt_select"]  = "onSptChange";
                    detailView.events["change .comp_select"]  = "onCompositeChange";
                    detailView.events["click .addOnPDP"] = 'onClickAddOnPDP'
                    detailView.events["click #includedItems"] = 'onHandleIncludedItems';
                    detailView.events["click .dynamicKitTabs"] = 'handleTabChange';
                    detailView.events['input .minorLineQuantity'] = 'handleMinorQuantityChange';
                    detailView.events['click .registerUser'] = 'gotoSecureRegistration';
                    detailView.handleMinorQuantityChange = function(event){
                        let id = event.currentTarget.dataset.id, parent = event.currentTarget.dataset.parent, _this = this, min = event.currentTarget.dataset.min
                        , guideData = _this.model.attributes.guideData, quantity = event.target.value, max = event.currentTarget.dataset.max;
                        if(quantity == ''){
                            quantity = 0;
                        } else {
                            quantity = parseInt(quantity);
                        }
                        guideData.forEach(function(guide){
                            if(guide.sfid == parent){
                                guide.compositeItems.forEach(function(item){
                                    if(item.component == id){
                                        let pl = {};
                                        item.componentR.tierList.forEach(function(priceList){
                                            if(priceList.currencyCode == CCRZ.userIsoCode){
                                                pl = priceList;
                                            }
                                        });
                                        //let _quantityObj = _this.validateMaxQuantity(pl, quantity);
                                        let _quantityObj = {
                                            'quantity' : quantity,
                                            'isMax' : false,
                                            'isMin' : false,
                                            'isAvailable' : true
                                        }
                                        if(!_.isUndefined(max) && (quantity > max)){
                                            _quantityObj.quantity = max;
                                            _quantityObj.isMax = true;
                                        }
                                        if(!_.isUndefined(min) && (quantity < min)){
                                            _quantityObj.quantity = min;
                                            _quantityObj.isMin = true;
                                        }
                                        item.quantity = Number(_quantityObj.quantity);
                                        $(event.target).val(_quantityObj.quantity);
                                        if(_quantityObj.isMax){
                                            CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM', severity : 'INFO',
                                                    message : CCRZ.processPageLabelMap('CHVAC_PDP_errorMax',[_quantityObj.quantity, guide.name]).toString(),
                                                    classToAppend : 'messagingAction-Info'
                                                    }
                                                ]
                                            });
                                            $('html, body').animate({
                                                'scrollTop' : $(".messagingAction-Info").position().top
                                            });
                                        }
                                        if(_quantityObj.isMin){
                                            CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM', severity : 'INFO',
                                                    message : CCRZ.processPageLabelMap('CHVAC_PDP_errorMin',[_quantityObj.quantity, guide.name]).toString(),
                                                    classToAppend : 'messagingAction-Info'
                                                    }
                                                ]
                                            });
                                            $('html, body').animate({
                                                'scrollTop' : $(".messagingAction-Info").position().top
                                            });
                                        }
                                    }
                                });
                            }
                        });
                        _this.model.set('guideData', guideData);
                        calculateBundlePrice(_this, false);
                        $('.productPrice').html(CCRZ.util.formatPrice(_this.model.get('productPrice'), CCRZ.userIsoCode));
                    };
                    detailView.handleTabChange = function(event){
                        let id = event.currentTarget.dataset.id, _this = this
                        , guideData = _this.model.attributes.guideData;
                        guideData.forEach(function(guide){
                            guide.checked = (guide.sfid == id)?true:false;
                        });
                        _this.model.set('guideData', guideData);
                        calculateBundlePrice(_this, false);
                        _this.render();
                    };
                    detailView.onHandleIncludedItems = function(event){
                        let sku = event.currentTarget.dataset.sku;
                        this.model.set('selectedSku', sku);
                        this.render();
                        setTimeout(() => {
                            runDefaultJsFunctions();
                            $('#bundleFlow').modal({backdrop: true, show: true}); 
                            $('#bundleFlow').removeClass('fade');
                        }, 300);
                    };
                    detailView.validateMaxQuantity = function(priceData, quantity){
                        let _obj = {"quantity" : quantity, "isMax" : false, "isAvailable": true};
                        if(!_.isUndefined(priceData.maxQuantity) && priceData.maxQuantity != null){
                            if(quantity > priceData.maxQuantity){
                                _obj.quantity = priceData.maxQuantity;
                                _obj.isMax = true;
                            }
                        } else {
                            _obj.isAvailable = false;
                        }
                        return _obj;
                    };
                    detailView.onCompositeChange = function(event){
                        CCRZ.showLoader();
                        let id = event.target.value;
                        let ProductType = detailView.model.attributes.product.prodBean.ProductType;
                        if(ProductType == "Aggregated"){
                            let compositeProds = detailView.model.attributes.product.prodBean.compositeProductsS;
                            if(compositeProds && compositeProds.length > 0){
                                compositeProds.forEach(function(prod, index){
                                    prod['isChecked'] = (id == prod.componentR.sfid?true:false);
                                });
                            }
                        }
                        calculateProductPrice(detailView, true);
                        setTimeout(() => {
                            detailView.render();
                        }, 500);
                    };
                    detailView.onHandleCompositeProducts = function(event){
                        let sku = event.currentTarget.dataset.sku, type= event.currentTarget.dataset.type, quantity = parseInt($('#quantity_' + sku).text());
                        quantity = (type=='inc'?(quantity+1):(type=='dec'?(quantity>0?quantity-1:quantity):quantity));
                        detailView.model.attributes.product.prodBean.compositeProductsS.forEach(function(product){
                            if(sku == product.componentR.SKU){
                                product.quantity = quantity;
                            }
                        });
                        if(ProductType == 'Dynamic Kit' || ProductType == 'Kit'){
                            calculateBundlePrice(detailView, true);
                        } else {
                            calculateProductPrice(detailView, true);
                        }
                        setTimeout(() => {
                            detailView.render();
                        }, 500);
                    }
                    detailView.gotoSecureRegistration = function(event) {
                        let secureUrl = CCRZ.pagevars.storeSettings.Site_Secure_Domain__c;
                        secureUrl = secureUrl + '/' + CCRZ.pagevars.storefrontName + '/ccrz__CCSiteRegister' + '?cartId=' + CCRZ.pagevars.currentCartID;
                        window.location = secureUrl;
                    }
                    detailView.onSptChange = function(event){
                        CCRZ.showLoader();
                        debugger;
                        detailView.model.set('frequencyTermId', event.target.value);
                        if(detailView.model.attributes.product.prodBean.isSubscriptionAvailable){
                            CCRZ.productDetailModel.attributes.subProdTerms.forEach(function(item){
                                if(item.sfid == event.target.value){
                                    detailView.model.set('frequencyTerm', item.installmentFrequencyUOM);
                                    UTIL.validateDisplayName(item, detailView);
                                } else if(event.target.value == ''){
                                    detailView.model.set('frequencyTerm', 'One-Time');
                                }
                            });
                        }
                        if(ProductType == 'Dynamic Kit' || ProductType == 'Kit'){
                            calculateBundlePrice(detailView, false);
                        } else {
                            calculateProductPrice(detailView, true);
                        }
                        setTimeout(() => {
                            detailView.render();
                        }, 500);
                    };
                    detailView.onClickAddOnPDP = function(event){
                        CCRZ.showLoader();
                        let isChecked = event.target.checked, relatedId = event.currentTarget.dataset.id;
                        if(detailView.model.attributes.relatedProducts.Accessories && detailView.model.attributes.relatedProducts.Accessories.length > 0){
                            detailView.model.attributes.relatedProducts.Accessories.forEach(function(related){
                                if(relatedId == related.prodBean.sfid){
                                    related.prodBean['isChecked'] = isChecked;
                                }
                            });
                        }
                        if(ProductType == 'Dynamic Kit' || ProductType == 'Kit'){
                            calculateBundlePrice(detailView, true);
                        } else {
                            calculateProductPrice(detailView, true);
                        }
                        setTimeout(() => {
                            detailView.render();
                        }, 500);
                    };
                    detailView.validateCartQuantity = function(event){
                        return CCRZ.util.isValidNumericInput(event);
                    };
                    detailView.onProductQuantityChange = function(event){
                        CCRZ.showLoader();
                        let _this = this;
                        let type = event.currentTarget.dataset.type, min = (event.currentTarget.dataset.min?parseInt(event.currentTarget.dataset.min):0);
                        var quantity = 0, cartQuantity = (_this.model.attributes.product.prodBean.cartData?(_this.model.attributes.product.prodBean.cartData.prodCartQuantity?_this.model.attributes.product.prodBean.cartData.prodCartQuantity:0):0);
                        try{
                            quantity = parseInt($("#product_quantity").val());
                        }catch(err){
                        }
                        if(!quantity || quantity <= 0){
                            quantity = min;
                            $("#product_quantity").val(quantity);
                        } 
                        let baseQty = quantity;
                        if(type == 'inc'){
                            baseQty = (quantity/min) + 1;
                            baseQty = baseQty * min;
                        } else if(type == 'dec'){
                            baseQty = (quantity/min) - 1;
                            baseQty = (baseQty < 1?(1 * min):(baseQty * min));
                        }
                        quantity = baseQty;
                        $("#product_quantity").val(quantity);
                        detailView.model.set('quantity', quantity);
                        calculateProductPrice(detailView, true);
                        setTimeout(() => {
                            detailView.render();
                        }, 500);
                    };
                    detailView.checkForCoterming = function(subTermId){
                        let isAddToCart = true, _this = this, cartItems = CCRZ.cartView.cartmodel;
                        if(!_.isUndefined(cartItems) && !_.isUndefined(cartItems.attributes.cartItems) && cartItems.attributes.cartItems.length > 0){
                            cartItems.attributes.cartItems.forEach(function(cartItem){
                                if(cartItem.mockProduct.sfid == _this.model.attributes.product.prodBean.sfid
                                    && subTermId == cartItem.subProdterm){
                                        isAddToCart = false;
                                    }
                            });
                        }
                        return isAddToCart;
                    };
                    detailView.clickedOnAddToCart = function(e){
                        let _this = this, frequencyTermId = detailView.model.get('frequencyTermId'), type = e.target.dataset.type;
                        var buttonclicked = $(e.target).attr("class");
                        if(type == 'addon' || !_this.model.attributes.product.prodBean.coTermEnforced || (_this.model.attributes.product.prodBean.coTermEnforced && _this.checkForCoterming(frequencyTermId))){
                            CCRZ.showLoader();
                            var quantity = detailView.model.get('quantity'), frequencyTerm = detailView.model.get('frequencyTerm'), parentSFID = detailView.model.attributes.product.prodBean.sfid;
                            let products = [], sku = detailView.model.attributes.product.prodBean.sku, isSubsc = detailView.model.attributes.product.prodBean.isSubscriptionAvailable, subTermId = null;
                            frequencyTerm = ((typeof frequencyTerm == 'undefined' || frequencyTerm == '')?'Yearly':frequencyTerm), sfid = detailView.model.attributes.product.prodBean.sfid;
                            let ProductType = detailView.model.attributes.product.prodBean.ProductType;
                            if(ProductType == "Aggregated"){
                                let compositeProds = detailView.model.attributes.product.prodBean.compositeProductsS;
                                if(compositeProds && compositeProds.length > 0){
                                    compositeProds.forEach(function(prod){
                                        if(prod.isChecked){
                                            sku = prod.componentR.SKU;
                                        }
                                    });
                                }
                            }(detailView.model.attributes.subProdTerms?detailView.model.attributes.subProdTerms[0].sfid:'');
                            if(type != 'addon'){
                                let productData = {
                                    "sku": sku,
                                    "sfid": sfid,
                                    "quantity": quantity,
                                    "subTermId" : frequencyTermId,
                                    "parentSFID" : null,
                                    "isMain" : (ProductType == 'Dynamic Kit' || ProductType == 'Kit')?true:false,
                                    "tierPriced": detailView.model.attributes.product.prodBean.tierPriced
                                };
                                products.push(productData);
                                if(ProductType == 'Dynamic Kit' || ProductType == 'Kit'){
                                    let guideData = _this.model.get('guideData');
                                    guideData.forEach(function(guide){
                                        if(guide.checked){
                                            guide.compositeItems.forEach(function(item){
                                                if(item.quantity > 0){
                                                    products.push({
                                                        "sku": item.componentR.SKU,
                                                        "sfid": item.componentR.sfid,
                                                        "quantity": item.quantity,
                                                        "parentSku" : sku
                                                    });
                                                }
                                            });
                                        }
                                    });
                                }
                            }
                            if(detailView.model.attributes.relatedProducts.Accessories){
                                let relAccessories = detailView.model.attributes.relatedProducts.Accessories;
                                if(relAccessories && relAccessories.length > 0){
                                    relAccessories.forEach(function(rel){
                                        if(rel.prodBean.isChecked){
                                            let productRelData = {
                                                "sku": null,
                                                "sfid" : null,
                                                "quantity": quantity,
                                                "parentSFID": null,
                                                "subTermId" : null,
                                                "isMain" : true
                                            };
                                            if(rel.prodBean.compositeProductsS){
                                                rel.prodBean.compositeProductsS.forEach(function(compositeProduct){
                                                    if(compositeProduct.isChecked){
                                                        productRelData.sku = compositeProduct.componentR.SKU;
                                                        productRelData.sfid = compositeProduct.componentR.sfid;
                                                    }
                                                });
                                            } else {
                                                productRelData.sku = rel.prodBean.sku;
                                                productRelData.sfid = rel.prodBean.sfid;
                                            }
                                            if(rel.prodBean.isSubscriptionAvailable && rel.subProdTerms && rel.subProdTerms.length > 0){
                                                rel.subProdTerms.forEach(function(relSPTRec){
                                                    if(relSPTRec.installmentFrequencyUOM == frequencyTerm){
                                                        productRelData['subTermId'] = relSPTRec.sfid;
                                                    }
                                                });
                                            }
                                            products.push(productRelData);
                                        }
                                    });
                                }
                            }
                            let reqData = {
                                "cartEncId": CCRZ.pagevars.currentCartID,
                                "products": products,
                                "currentUserCurrency" : CCRZ.pagevars.remoteContext.userIsoCode
                            }
                            debugger;
                            if((type != 'addon' && quantity && quantity > 0) || (type == 'addon' && products.length > 0)){
                                CCRZ.remoteActions.pdpRemoting.className = 'CHVACB2B_pdp_Controller';
                                CCRZ.remoteActions.pdpRemoting.addToCart(JSON.stringify(reqData),function(res,event){
                                    if(res && res.success && res.data && res.data.cartEncId){
                                        if(buttonclicked.indexOf("buy_now_button") >= 0){
                                            window.open(UTIL.getNavigateURL('cart', {'cartId': res.data.cartEncId}), '_self');
                                        } else {
                                            if(res.data.cartData){
                                                CCRZ.productDetailModel.attributes.product.prodBean.cartData = res.data.cartData;
                                            }
                                            if(res.data.cartEncId){
                                                try{
                                                    CCRZ.pagevars.currentCartID = res.data.cartEncId;
                                                    CCRZ.pagevars.queryParams['cartId'] = res.data.cartEncId;  
                                                    CCRZ.pubSub.trigger('cartChange', res.data.cartEncId);
                                                }catch(err){}
                                            }
                                            if(CCRZ.pagevars.currentCartID && CCRZ.pagevars.currentCartID.trim().length > 0){
                                                setTimeout(function(){
                                                    _this.render();
                                                }, 2000);
                                            } else {
                                                CCRZ.hideLoader();
                                            }
                                            $('#sidebar').addClass('active');
                                            $('.sidebarMiniCart').removeClass('hide');
                                        }
                                    } else {
                                        console.log('Error adding product to cart');
                                        CCRZ.hideLoader();
                                    }
                                });
                            }else{
                                let errorMessage = '';
                                if(products.length == 0){
                                    errorMessage = CCRZ.processPageLabelMap('CHVAC_PDP_errorAddOns', []).toString();
                                } else if(!quantity && quantity == 0){
                                    errorMessage = CCRZ.processPageLabelMap('CHVAC_PDP_errorQuantity', []).toString();
                                }
                                CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM', severity : 'ERROR',
                                    message : errorMessage,
                                    classToAppend : 'messagingAction-Info'
                                        }
                                    ]
                                });
                                $('html, body').animate({
                                    'scrollTop' : $(".messagingAction-Info").position().top
                                });
                                CCRZ.hideLoader();
                            }
                        } else {
                            CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM', severity : 'ERROR',
                                    message : CCRZ.processPageLabelMap('CHVAC_PDP_errorSubscAvaiilable', []).toString(),
                                    classToAppend : 'messagingAction-Info'
                                    }
                                ]
                            });
                            $('html, body').animate({
                                'scrollTop' : $(".messagingAction-Info").position().top
                            });
                        }
                    };
                    detailView.clickedOnAddBoltOn = function(event){
                        let _this = this;
                        var target = $(event.target);
                        var parentSFID = event.currentTarget.dataset.sfid;
                        var className = event.target.classList;
                        var productSFID = '';
                        var reqData = {
                            "cartEncId": CCRZ.pagevars.currentCartID,
                            "quantity": 1,
                            "sellerId": CCRZ.productDetailModel.attributes.product.sellerID,
                            "sptSFID": null,
                            "currentUserCurrency" : CCRZ.pagevars.remoteContext.userIsoCode,
                            "tierPriced": false,
                            "isAdd": true,
                            "isAddOn": true, 
                            "mainProdSKU": CCRZ.pagevars.queryParams.sku,
                            "isFullQuantity": false,
                            "parentSFID": null
                        };
                        let isComposite = false;
                        if(className.length > 0){
                            for(let i = 0; i < className.length; i++){
                                if(className[i].indexOf("is-composite") >= 0){
                                    isComposite = true;
                                }
                            }
                        }
                        if(isComposite){
                            productSFID = $("#product_drop_"+parentSFID).val();
                            reqData['parentSFID'] = parentSFID;
                            reqData['sku'] = $("#selectedprod_sku_"+parentSFID).html();
                        }else{
                            productSFID = parentSFID+'';
                            reqData['sku'] = event.currentTarget.dataset.sku;
                        }
                        reqData['productSFID'] = productSFID;
                        CCRZ.showLoader();
                        CCRZ.remoteActions.pdpRemoting.className = 'CHVACB2B_pdp_Controller';
                        CCRZ.remoteActions.pdpRemoting.addToCart(JSON.stringify(reqData),function(res,event){
                            if(res && res.data && res.data.cartData && res.data.cartInfo && res.data.cartInfo.cartList.length){
                                CCRZ.productDetailModel.attributes.product.prodBean.cartData = res.data.cartData;
                                CCRZ.headerView.updateCart(res.data.cartInfo);
                            } else {
                                CCRZ.hideLoader();
                            }
                            if(!CCRZ.pagevars.currentCartID || CCRZ.pagevars.currentCartID.trim().length <= 0){
                                try{
                                    CCRZ.pagevars.currentCartID = res.data.cartEncId;
                                    CCRZ.pagevars.queryParams['cartId'] = res.data.cartEncId;
                                }catch(err){}
                            }
                            if(CCRZ.pagevars.currentCartID && CCRZ.pagevars.currentCartID.trim().length > 0){
                                _this.render();
                                setTimeout(() => {
                                    runDefaultJsFunctions();
                                }, 500);
                            } else {
                                window.open(UTIL.getNavigateURL('pdp', {'sku': CCRZ.pagevars.queryParams.sku, 'cartID': CCRZ.pagevars.currentCartID.trim()}), '_self');
                            }
                        });
                    };
                    detailView.onCompositeProductChange = function(event){
                        let _this = this;
                        var parentSFID = event.currentTarget.dataset.parentsfid;
                        var selectedProdId = event.currentTarget.value;
                        var relatedList = _this.model.attributes.relatedProducts;
                        if(relatedList && relatedList.Accessories && relatedList.Accessories.length > 0){
                            relatedList.Accessories.forEach(function(accessory){
                                if(accessory.prodBean.ProductType == 'Aggregated' && accessory.prodBean.sfid == parentSFID){
                                    accessory.prodBean.compositeProductsS.forEach(function(composite){
                                        composite.isChecked = (composite.componentR.sfid == selectedProdId)?true:false;
                                    });
                                }
                            });
                            calculateProductPrice(detailView, true);
                            setTimeout(() => {
                                detailView.render();
                            }, 500);
                        }
                    };
                    detailView.delegateEvents();
                    detailView.renderDesktop = function(){
                        var v = this;
                        v.$el.html('');
                        $(CCRZ.uiProperties.productDetailView.desktop.right.selector).html('');
                        this.setElement($(CCRZ.uiProperties.productDetailView.desktop.main.selector));
                        v.$el.html(v.templateDesktop(v.model.toJSON()));
                        runDefaultJsFunctions();
                        if(v.model.attributes.product.prodBean.isSubscExpiredActive){
                            CCRZ.pubSub.trigger('pageMessage',{messages:[{type : 'CUSTOM', severity : 'ERROR',
                                    message : CCRZ.processPageLabelMap('CHVAC_PDP_subscriptionAvailableError').toString(),
                                    classToAppend : 'messagingAction-Info'
                                    }
                                ]
                            });
                            $('html, body').animate({
                                'scrollTop' : $(".messagingAction-Info").position().top
                            });
                        }
                        CCRZ.hideLoader();
                    };
                    isRefreshed = true;
                    detailView.render();
            });

            // Set CompositeItem to the guide
            function setDynamicKitDataToGuide(detailView){
                let compositeItems = detailView.model.attributes.product.prodBean.compositeProductsS
                , guideData = detailView.model.attributes.guideData;
                if(!_.isUndefined(compositeItems) && !_.isUndefined(guideData) && compositeItems.length && guideData.length > 0){
                    let compositeGroupMap = new Map();
                    compositeItems.forEach(function(composite){
                        composite.componentR.tierList = UTIL.checkForBestPricePerCurrency(composite.componentR.tierList);
                        if(composite.optional){
                            composite.quantity = 1;
                            if(composite.componentR.sfdcName.match(/limited/i)){
                                composite.quantity = 0;
                            }
                        }
                        if(compositeGroupMap.has(composite.productGroup)){
                            let compositeItems = compositeGroupMap.get(composite.productGroup);
                            compositeItems.push(composite);
                            compositeGroupMap.set(composite.productGroup, compositeItems);
                        } else {
                            compositeGroupMap.set(composite.productGroup, [composite]);
                        }
                    });
                    guideData.forEach(function(guide, index){
                        if(index == 0){
                            guide['checked'] = true;
                        } else {
                            guide['checked'] = false;
                        }
                        guide['compositeItems'] = compositeGroupMap.get(guide.relatedProductGroup);
                    });
                }
                detailView.model.attributes.guideData = guideData;
            }
            //Calculate kits and dynamic kits 
            function calculateBundlePrice(detailView, isChange){
                let productPrice = 0, frequencyTermId = detailView.model.get('frequencyTermId')
                , guideData = detailView.model.attributes.guideData, compositeItems = [];
                guideData.forEach(function(guide, index){
                    if(guide.checked){
                        compositeItems = guide['compositeItems'];
                    }
                });
                if(compositeItems.length > 0){
                    compositeItems.forEach(function(product){
                        if(product.quantity > 0){
                            product.componentR.tierList.forEach(function(priceList, index){
                                if(priceList.currencyCode == CCRZ.userIsoCode){
                                    productPrice += priceList.listPrice * product.quantity;
                                }
                            });
                        }
                    });
                } else {
                    productPrice = 0;
                }
                if(detailView.model.attributes.subProdTerms && detailView.model.attributes.subProdTerms.length > 0){
                    detailView.model.attributes.subProdTerms.forEach(function(spt){
                        if(frequencyTermId != '' && spt.sfid == frequencyTermId){
                            productPrice = (productPrice/100) * spt.upfrontPricePercentage;
                        }
                    });
                }
                let addOnPrice = calculateAddOn(detailView, isChange);
                detailView.model.set('addOnPrice', addOnPrice);
                detailView.model.set('productPrice', productPrice);
            }
            // Calculate Normal, Subscription, Tier-Priced and Aggregate products
            function calculateProductPrice(detailView, isChange){
                let addOnPrice = 0, productPrice = 0, quantity = detailView.model.get('quantity'), frequencyTermId = detailView.model.get('frequencyTermId'), frequencyTerm = detailView.model.get('frequencyTerm');
                if(detailView.model.attributes.product.prodBean.DCMB2BIsTrialProduct){
                    frequencyTermId = (detailView.model.attributes.subProdTerms?detailView.model.attributes.subProdTerms[0].sfid:'');
                }
                addOnPrice = calculateAddOn(detailView, isChange);
                let ProductType = detailView.model.attributes.product.prodBean.ProductType;
                if(ProductType == "Aggregated"){
                    let compositeProds = detailView.model.attributes.product.prodBean.compositeProductsS;
                    if(compositeProds && compositeProds.length > 0){
                        compositeProds.forEach(function(prod){
                            if(prod.isChecked){
                                prod.componentR.tierList.forEach(function(priceList){
                                    if(priceList.currencyCode == CCRZ.userIsoCode){
                                        productPrice = priceList.listPrice;
                                    }
                                });
                            }
                        });
                    }
                }
                if(detailView.model.attributes.product.prodBean.isSubscriptionAvailable){
                    if(detailView.model.attributes.subProdTerms && detailView.model.attributes.subProdTerms.length){
                        detailView.model.attributes.subProdTerms.forEach(function(spt){
                            if(spt.sfid == frequencyTermId){
                                productPrice = (spt.productPrice);
                            } else if(spt.CC_NO_SUBSCRIPTION){
                                productPrice = spt.productPrice;
                            }
                        });
                    }
                } else if(ProductType == 'Product'){
                    productPrice = detailView.model.attributes.product.prodBean.price;
                }
                detailView.model.set('productPrice', productPrice);
                detailView.model.set('addOnPrice', addOnPrice);
            }

            // Calculate AddOnPrice
            function calculateAddOn(detailView, isChange){
                let addOnPrice = 0, frequencyTerm = 'Yearly'; // TBD for now only yearly
                if(!isChange){
                    if(detailView.model.attributes.relatedProducts.Accessories && detailView.model.attributes.relatedProducts.Accessories.length > 0){
                        detailView.model.attributes.relatedProducts.Accessories.forEach(function(related){
                            let relProductType = related.prodBean.ProductType;
                            if(relProductType == "Aggregated"){
                                let compositeProds = related.prodBean.compositeProductsS;
                                if(compositeProds && compositeProds.length > 0){
                                    compositeProds.forEach(function(prod, index){
                                        prod['isChecked'] = (index == 0?true:false);
                                    });
                                }
                            }
                        });
                    }
                }
                if(detailView.model.attributes.product.prodBean.ERelatedProductsS && detailView.model.attributes.product.prodBean.ERelatedProductsS.length > 0){
                    detailView.model.attributes.product.prodBean.ERelatedProductsS.forEach(function(relatedItem){
                        if(relatedItem.relatedProductType == 'Accessories'){
                            if(detailView.model.attributes.relatedProducts.Accessories && detailView.model.attributes.relatedProducts.Accessories.length > 0){
                                detailView.model.attributes.relatedProducts.Accessories.forEach(function(related){
                                    if(relatedItem.relatedProduct == related.prodBean.sfid){
                                        related.prodBean['DCMRequired'] = relatedItem.DCMRequired;
                                        if(!isChange){
                                            related.prodBean['isChecked'] = relatedItem.DCMRequired;
                                        }
                                        if(related.prodBean.isSubscriptionAvailable){
                                            if(related.subProdTerms && related.subProdTerms.length > 0){
                                                related.subProdTerms.forEach(function(spt){
                                                    if(spt.installmentFrequencyUOM == frequencyTerm && related.prodBean.isChecked){
                                                        addOnPrice += (spt.productPrice);
                                                    }
                                                });
                                            }
                                        } else {
                                            if(related.prodBean.ProductType == 'Aggregated' && related.prodBean.isChecked){
                                                let compositeProds = related.prodBean.compositeProductsS;
                                                if(compositeProds && compositeProds.length > 0){
                                                    compositeProds.forEach(function(prod){
                                                        if(prod.isChecked){
                                                            prod.componentR.tierList.forEach(function(priceList){
                                                                if(priceList.currencyCode == CCRZ.userIsoCode){
                                                                    addOnPrice += priceList.listPrice;
                                                                }
                                                            });
                                                        }
                                                    });
                                                }
                                            } else if(related.prodBean.isChecked){
                                                addOnPrice += related.prodBean.price;
                                            }
                                        }
                                    }
                                });
                            }
                        }
                        
                    });
                }
                return addOnPrice;
            }
        
        }
            
    }
    
});

